# -*- encoding: utf-8 -*-

import django.contrib.auth
from django.contrib.auth.forms import  UserCreationForm, UserChangeForm
from models import AUFUser, USERNAME_LENGTH, USERNAME_REGEXP, USERNAME_HELP

class AUFUserCreationForm(UserCreationForm):
    username = forms.RegexField(label=_("Username"), max_length=USERNAME_LENGTH, regex=USERNAME_REGEXP,
        help_text = _(USERNAME_HELP),
        error_messages = {'invalid': _(USERNAME_HELP)})

class AUFUserChangeForm(UserChangeForm):
    username = forms.RegexField(label=_("Username"), max_length=USERNAME_LENGTH, regex=USERNAME_REGEXP,
        help_text = _(USERNAME_HELP),
        error_messages = {'invalid': _(USERNAME_HELP)})

# Remplace les formulaires pour fonctionner avec le modèle patché des users Django
django.contrib.auth.forms.UserCreationForm = AUFUserCreationForm
django.contrib.auth.forms.UserChangeForm = AUFUserChangeForm
django.contrib.auth.forms.UserChangeForm.Meta.exclude = ('password', )

