# -*- encoding: utf-8 -*-

from django.db import models
from django.db.models.signals import pre_save, pre_init, pre_delete
from django.contrib.auth.models import User, UserManager, get_hexdigest, check_password as django_check_password
from django.core.validators import email_re
from django.utils.translation import ugettext_lazy as _
import django.contrib.auth
import django.contrib.auth.forms

USERNAME_LENGTH = 75
USERNAME_REGEXP = email_re
USERNAME_HELP =  "L'identifiant doît être un courriel."


def set_password(user, raw_password):
    """Défini un mot de passe md5"""
    user.password = get_hexdigest('md5', '', raw_password)

def check_password(user, raw_password):
    """
    Test la correspondance du mot de passe md5.
    S'il a été haché avec le système django par défaut,
    il le transforme sous pour le crypter en md5.
    """
    if len(user.password) != 32:
        if django_check_password(raw_password, user.password):
            user.set_password(raw_password)
            user.save()
    return get_hexdigest('md5', '', raw_password) == user.password


def save(user, **kwargs):
    return super(User, user).save(**kwargs)

def delete(user, **kwargs):
    return super(User, user).delete(**kwargs)


django.contrib.auth.models.User._meta.get_field_by_name('username')[0].max_length = USERNAME_LENGTH
django.contrib.auth.models.User._meta.get_field_by_name('username')[0].help_text = USERNAME_HELP
django.contrib.auth.models.User._meta.get_field_by_name('password')[0].help_text = "<a href=\"password/\">Changer le mot de passe</a>"

django.contrib.auth.models.User.set_password = set_password
django.contrib.auth.models.User.check_password = check_password
django.contrib.auth.models.User.save = save
django.contrib.auth.models.User.delete = delete
